  .686                   ; set processor type, another option is .386
  .model flat, stdcall   ; memory model & calling convention
  option casemap :none   ; case sensitive

  ; ----------------------------------------------
  ; Include any needed INCLUDE and LIBRARY files
  ; and procedure prototypes.
  ; ----------------------------------------------
  include \masm32\include\windows.inc
  include \masm32\include\user32.inc
  include \masm32\include\kernel32.inc

  includelib \masm32\lib\user32.lib
  includelib \masm32\lib\kernel32.lib

  ; ---------------------------------------------------
  ; Include any needed global constants and variables
  ; both initialized and uninitialized
  ; ---------------------------------------------------
.const
    con_init equ 255
.data
  m0   dd 0
  m1   dd 0
  _esi dd 0
  _edi dd 0

  szCap    db "Use same code from two places",0
  szFinish db "Program finished",0
  szRegHex db "%010lu  ESI source index",13,10
           db "%010lu  EDI destination index",13,10,0
           
  szBufHex db 256 dup (0)
          
.code
start:

  mov m0, 1234567
  mov m1, 1234999
  mov esi, 0
  mov edi, 0

L0:
  cmp esi, m0
  je  Display0    ; Some alternative using a conditional call

  ; -= OR =-
  ;  jne L1
  ;  call Display
L1:
  inc esi
  cmp esi, m1

  je  L2          ; Is  jne L0  a better choice? Would be true almost always.
  jmp L0
L2:
  jmp Display1    ; Some alternative using a call

  ; -= OR =-
  ;   je  L2
  ;   jmp L0
  ; L2:
  ;   call Display

  ; -= OR =-
  ;   jne L0
  ;   call Display

L3:
  inc edi
  cmp edi, 2
  je  Past
  jmp L0

Display0:
  mov _esi, esi
  mov _edi, edi
  invoke wsprintf, ADDR szBufHex, ADDR szRegHex, esi, edi
  invoke MessageBox, 0, ADDR szBufHex, Addr szCap, MB_OK
  mov esi, _esi
  mov edi, _edi
  jmp L1

Display1:
  mov _esi, esi
  mov _edi, edi
  invoke wsprintf, ADDR szBufHex, ADDR szRegHex, esi, edi
  invoke MessageBox, 0, ADDR szBufHex, Addr szCap, MB_OK
  mov esi, _esi
  mov edi, _edi
  jmp L3

Display:
  mov _esi, esi
  mov _edi, edi
  invoke wsprintf, ADDR szBufHex, ADDR szRegHex, esi, edi
  invoke MessageBox, 0, ADDR szBufHex, Addr szCap, MB_OK
  mov esi, _esi
  mov edi, _edi
  ret

Past:
  invoke MessageBox, 0, ADDR szFinish, Addr szCap, MB_OK
  invoke ExitProcess,0

end start